import java.lang.*;
import java.io.*;
import java.util.*;

public class getdata
{
  public int number_of_lines;
  public LinkedList linearray = new LinkedList();
  public LinkedList drivearray = new LinkedList();
  public dllObj dll_object = new dllObj();
  public String windows_path = new String();
  public dllObj tmpdll_obj = new dllObj();
  public x11Obj x11_obj = new x11Obj();
  public fontObj font_obj = new fontObj();
  public hwObj hw_obj = new hwObj();
  public afmdirsObj afmdirs_obj = new afmdirsObj();
  public registryObj registry_obj = new registryObj();
  public layoutObj layout_obj = new layoutObj();
  public clipboardObj clipboard_obj = new clipboardObj();
  public winmmObj winmm_obj = new winmmObj();
  public consoleObj console_obj = new consoleObj();
  public LinkedList afmdirsarray = new LinkedList();
  private int first_drivers;

  public LinkedList load_config(String fopenname)
  {
  System.out.print("\n\nDateiname:"+fopenname+"\n\n");
    try
    {
      boolean eof = false;
      String tmpline = new String();

      FileReader wineconfig = new FileReader(fopenname);
      LineNumberReader lnrconfig = new LineNumberReader(wineconfig);

      while(!eof)
      {
        tmpline = lnrconfig.readLine();
        number_of_lines=lnrconfig.getLineNumber();
        if(tmpline== null)
        {
          eof = true;
        }
        if(tmpline !=null)
        {
          lineObj tmpline_obj = new lineObj(tmpline, number_of_lines);//Make a temp_obj for storing to array_list
          linearray.add(tmpline_obj);                           //Add the current Datas to array
        }
      }
      wineconfig.close();
    }catch (IOException e){System.out.println("Fehler: datei konnte nicht geffnet werden!"+e.getMessage());}

    return linearray;
  }

   public registryObj load_registry()
  {
    lineObj tmpline_obj;
    parser parser = new parser();
    String currentline = new String();

    for(int i=0; i < linearray.size(); i++)
    {
      tmpline_obj=(lineObj) linearray.get(i);
      currentline=tmpline_obj.line;

      parser.parse(currentline, "LoadGlobalRegistryFiles");
      if(parser.ok==true)
      {
        registry_obj.loadglobalrf=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "LoadHomeRegistryFiles");
      if(parser.ok==true)
      {
        registry_obj.loadhomerf=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "LoadWindowsRegistryFiles");
      if(parser.ok==true)
      {
        registry_obj.loadwindowsrf=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "WritetoHomeRegistryFiles");
      if(parser.ok==true)
      {
        registry_obj.writehomerf=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "PeriodicSave");
      if(parser.ok==true)
      {
        registry_obj.periodicsave=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "SaveOnlyUpdatedKeys");
      if(parser.ok==true)
      {
        registry_obj.saveonlyupdated=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }
    }
    return registry_obj;
  }

   public layoutObj load_layout()
  {
    lineObj tmpline_obj;
    parser parser = new parser();
    String currentline = new String();

    for(int i=0; i < linearray.size(); i++)
    {
      tmpline_obj=(lineObj) linearray.get(i);
      currentline=tmpline_obj.line;

      parser.parse(currentline, "WineLook");
      if(parser.ok==true)
      {
        layout_obj.winelook=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }
    }
    return layout_obj;
  }

   public consoleObj load_console()
  {
    lineObj tmpline_obj;
    parser parser = new parser();
    String currentline = new String();

    for(int i=0; i < linearray.size(); i++)
    {
      tmpline_obj=(lineObj) linearray.get(i);
      currentline=tmpline_obj.line;


      parser.parse(currentline, "Drivers");
      if((parser.ok==true)&&(!(parser.value_of_line.equals("wineoss.drv"))))
      {
        console_obj.firstdriversentry=i;
        console_obj.drivers=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "XtermProg");
      if(parser.ok==true)
      {
        console_obj.xtermprog=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "InitialRows");
      if(parser.ok==true)
      {
        console_obj.initialrows=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "InitialColumns");
      if(parser.ok==true)
      {
        console_obj.initialcolumns=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "TerminalType");
      if(parser.ok==true)
      {
        console_obj.terminaltype=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }
    }
    return console_obj;
  }

   public winmmObj load_winmm(consoleObj tmpcon)
  {
    lineObj tmpline_obj;
    parser parser = new parser();
    String currentline = new String();

    for(int i=tmpcon.firstdriversentry; i < linearray.size(); i++) //Search for "Drivers" but after the first from console!
    {
      tmpline_obj=(lineObj) linearray.get(i);
      currentline=tmpline_obj.line;

      parser.parse(currentline, "Drivers");
      if(parser.ok==true)
      {
        winmm_obj.drivers=parser.value_of_line;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }
      parser.parse(currentline, "WaveMapper");
      if(parser.ok==true)
      {
        winmm_obj.wavemapper=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }
      parser.parse(currentline, "MidiMapper");
      if(parser.ok==true)
      {
        winmm_obj.midimapper=parser.value_of_line;
        //DONT jump here on line more- heres the eof!
      }
    }
    return winmm_obj;
  }

   public LinkedList load_afmdirs()
  {
    lineObj tmpline_obj;
    parser parser = new parser();
    String currentline = new String();
    afmdirsObj afmdir_obj;
    int afmnumber=1;
    String tmpstring = new String();


    for(int i=0; i < linearray.size(); i++)
    {
      tmpline_obj=(lineObj) linearray.get(i);
      currentline=tmpline_obj.line;
      parser.parse(currentline, tmpstring.valueOf(afmnumber));
      if(parser.ok==true)
      {
        afmdir_obj = new afmdirsObj();
        afmdir_obj.afmdir=parser.value_of_line;
        afmdir_obj.afmdirnumber=afmnumber;
        afmdirsarray.add(afmdir_obj);
        afmnumber++;
      }
    }

    return afmdirsarray;
  }

   public clipboardObj load_clipboard()
  {
    lineObj tmpline_obj;
    parser parser = new parser();
    String currentline = new String();

    for(int i=0; i < linearray.size(); i++)
    {
      tmpline_obj=(lineObj) linearray.get(i);
      currentline=tmpline_obj.line;

      parser.parse(currentline, "ClearAllSelections");
      if(parser.ok==true)
      {
        clipboard_obj.clearallselections=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "PersistentSelection");
      if(parser.ok==true)
      {
        clipboard_obj.persistentselection=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }
    }
    return clipboard_obj;
  }

   public hwObj load_hw()
  {
    lineObj tmpline_obj;
    parser parser = new parser();
    String currentline = new String();

    for(int i=0; i < linearray.size(); i++)
    {
      tmpline_obj=(lineObj) linearray.get(i);
      currentline=tmpline_obj.line;

      parser.parse(currentline, "Com1");
      if(parser.ok==true)
      {
        hw_obj.com1=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Com2");
      if(parser.ok==true)
      {
        hw_obj.com2=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Com3");
      if(parser.ok==true)
      {
        hw_obj.com3=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Com4");
      if(parser.ok==true)
      {
        hw_obj.com4=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Lpt1");
      if(parser.ok==true)
      {
        hw_obj.lpt1=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Lpt2");
      if(parser.ok==true)
      {
        hw_obj.lpt2=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Lpt3");
      if(parser.ok==true)
      {
        hw_obj.lpt3=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Lpt4");
      if(parser.ok==true)
      {
        hw_obj.lpt4=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "378");
      if(parser.ok==true)
      {
        hw_obj.ppd378=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "278");
      if(parser.ok==true)
      {
        hw_obj.ppd278=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "3bc");
      if(parser.ok==true)
      {
        hw_obj.ppd3bc=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "FILE:");
      if(parser.ok==true)
      {
        hw_obj.spfile=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "LPT1:");
      if(parser.ok==true)
      {
        hw_obj.splpt1=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "LPT2:");
      if(parser.ok==true)
      {
        hw_obj.splpt2=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "LPT3:");
      if(parser.ok==true)
      {
        hw_obj.splpt3=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "read");
      if(parser.ok==true)
      {
        hw_obj.portread=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "write");
      if(parser.ok==true)
      {
        hw_obj.portwrite=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Exclude");
      if(parser.ok==true)
      {
        hw_obj.spy=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }
    }
    return hw_obj;
  }

   public x11Obj load_x11()
  {
    boolean loadok=true;
    lineObj tmpline_obj;
    parser parser = new parser();
    String currentline = new String();


    for(int i=0; i < linearray.size(); i++)
    {
      tmpline_obj=(lineObj) linearray.get(i);
      currentline=tmpline_obj.line;

      parser.parse(currentline, "AllocSystemColors");
      if(parser.ok==true)
      {
        x11_obj.alloccolors=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "PrivateColorMap");
      if(parser.ok==true)
      {
        x11_obj.privatecolormap=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "PerfectGraphics");
      if(parser.ok==true)
      {
        x11_obj.perfectgraphics=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "ScreenDepth");
      if(parser.ok==true)
      {
        x11_obj.screendepth=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Display");
      if(parser.ok==true)
      {
        x11_obj.display=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Managed");
      if(parser.ok==true)
      {
        x11_obj.managed=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Desktop");
      if(parser.ok==true)
      {
        x11_obj.desktop=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      //Toke the deskzop-string into two
      x11_obj.tokdektop();

      parser.parse(currentline, "UseDGA");
      if(parser.ok==true)
      {
        x11_obj.dga=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "UseXShm");
      if(parser.ok==true)
      {
        x11_obj.xshm=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "UseXVidMode");
      if(parser.ok==true)
      {
        x11_obj.xvidmode=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "DXGrab");
      if(parser.ok==true)
      {
        x11_obj.dxgrab=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "DesktopDoubleBuffered");
      if(parser.ok==true)
      {
        x11_obj.doublebuffer=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "TextCP");
      if(parser.ok==true)
      {
        x11_obj.textcp=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "XVideoPort");
      if(parser.ok==true)
      {
        x11_obj. xvideoport=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Synchronous");
      if(parser.ok==true)
      {
        x11_obj.synchronous=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }


    }
    return x11_obj;
  }

   public fontObj load_fonts()
  {
    lineObj tmpline_obj;
    parser parser = new parser();
    String currentline = new String();

    for(int i=0; i < linearray.size(); i++)
    {
      tmpline_obj=(lineObj) linearray.get(i);
      currentline=tmpline_obj.line;

      parser.parse(currentline, "Resolution");
      if(parser.ok==true)
      {
        font_obj.resolution=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "Default");
      if(parser.ok==true)
      {
        font_obj.defaultfont=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "DefaultFixed");
      if(parser.ok==true)
      {
        font_obj.fixed=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "DefaultSerif");
      if(parser.ok==true)
      {
        font_obj.serif=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "DefaultSansSerif");
      if(parser.ok==true)
      {
        font_obj.sansserif=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }
    }
    return font_obj;
  }

   public dllObj load_pathdlls()
  {
    boolean loadok=true;
    lineObj tmpline_obj;
    parser parser = new parser();
    String currentline = new String();

    for(int i=0; i < linearray.size(); i++)
    {
      tmpline_obj=(lineObj) linearray.get(i);
      currentline=tmpline_obj.line;

      parser.parse(currentline, "windows");
      if(parser.ok==true)             //If erverything went OK the swith to next line...
      {
        tmpdll_obj.windir=parser.value_of_line;
        i++;                         // See this as performance tuning -> If in the next line is that stuff below, we dont need to check all this stuff again ;_)
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "system");
      if(parser.ok==true)
      {
        tmpdll_obj.sysdir=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "path");
      if(parser.ok==true)
      {
        int counter=0;
        tmpdll_obj.pathdir=parser.value_of_line;
        //Now we split the many paths into an array
        StringTokenizer st = new StringTokenizer(tmpdll_obj.pathdir, ";");

        while(st.hasMoreTokens()==true)
        {

          tmpdll_obj.dllpaths.add(st.nextToken());
          //System.out.print("\n"+tmpdll_obj.dllpaths.get(counter));
          counter++;
        }

        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "temp");
      if(parser.ok==true)
      {
        tmpdll_obj.tempdir=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "commdlg");
      if(parser.ok==true)
      {
        tmpdll_obj.commdlg=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "comdlg32");
      if(parser.ok==true)
      {
        tmpdll_obj.comdlg32=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "ver");
      if(parser.ok==true)
      {
        tmpdll_obj.ver=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "version");
      if(parser.ok==true)
      {
        tmpdll_obj.version=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "shell");
      if(parser.ok==true)
      {
        tmpdll_obj.shell=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "shell32");
      if(parser.ok==true)
      {
        tmpdll_obj.shell32=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "shfolder");
      if(parser.ok==true)
      {
        tmpdll_obj.shfolder=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "shlwapi");
      if(parser.ok==true)
      {
        tmpdll_obj.shlwapi=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "lzexpand");
      if(parser.ok==true)
      {
        tmpdll_obj.lzexpand=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "lz32");
      if(parser.ok==true)
      {
        tmpdll_obj.lz32=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "comctl32");
      if(parser.ok==true)
      {
        tmpdll_obj.comctl32=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "commctrl");
      if(parser.ok==true)
      {
        tmpdll_obj.commctrl=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "advapi32");
      if(parser.ok==true)
      {
        tmpdll_obj.advapi32=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "crtdll");
      if(parser.ok==true)
      {
        tmpdll_obj.crtdll=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "mpr");
      if(parser.ok==true)
      {
        tmpdll_obj.mpr=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "winspool.drv");
      if(parser.ok==true)
      {
        tmpdll_obj.winspool=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "ddraw");
      if(parser.ok==true)
      {
        tmpdll_obj.ddraw=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "dinput");
      if(parser.ok==true)
      {
        tmpdll_obj.dinput=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "dsound");
      if(parser.ok==true)
      {
        tmpdll_obj.dsound=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "opengl32");
      if(parser.ok==true)
      {
        tmpdll_obj.opengl32=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "msvcrt");
      if(parser.ok==true)
      {
        tmpdll_obj.msvcrt=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "rpcrt4");
      if(parser.ok==true)
      {
        tmpdll_obj.rpcrt4=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "msvideo");
      if(parser.ok==true)
      {
        tmpdll_obj.msvideo=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "msvfw32");
      if(parser.ok==true)
      {
        tmpdll_obj.msvfw32=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "mcicda.drv");
      if(parser.ok==true)
      {
        tmpdll_obj.mcicda=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "mciseq.drv");
      if(parser.ok==true)
      {
        tmpdll_obj.mciseq=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "mciwave.drv");
      if(parser.ok==true)
      {
        tmpdll_obj.mciwave=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "mciavi.drv");
      if(parser.ok==true)
      {
        tmpdll_obj.mciavi=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "mcianim.drv");
      if(parser.ok==true)
      {
        tmpdll_obj.mcianim=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "msacm.drv");
      if(parser.ok==true)
      {
        tmpdll_obj.msacm_drv=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "msacm");
      if(parser.ok==true)
      {
        tmpdll_obj.msacm=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "msacm32");
      if(parser.ok==true)
      {
        tmpdll_obj.msacm32=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "midimap.drv");
      if(parser.ok==true)
      {
        tmpdll_obj.midimap=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }

      parser.parse(currentline, "*");
      if(parser.ok==true)
      {
        tmpdll_obj.defaultsetting=parser.value_of_line;
        i++;
        tmpline_obj=(lineObj) linearray.get(i);
        currentline=tmpline_obj.line;
      }
    }
    return tmpdll_obj;
  }

   public LinkedList load_drives()
  {
    lineObj tmpline_obj;
    boolean ok=true;
    driveObj tmpdrive_obj;
    String tmpname = new String();
    String tmpvalue_of_Path = new String();
    String tmpvalue_of_Type = new String();
    String tmpvalue_of_Device = new String();
    String tmpvalue_of_Filesystem =new String();
    //Please enhance this bit of code, its really terrible!
    for(int i=0; i < linearray.size(); i++)
    {
      tmpline_obj=(lineObj) linearray.get(i);
      if((tmpline_obj.line.length())>6)                //Check if string of this line is bigger as 6 -> for check below..
      {
        if((tmpline_obj.line.substring(0,6).equals("[Drive"))==true) //Check if this line contains drive...
        {
          tmpname=tmpline_obj.line.substring(7,8);       //Get name of this Drive
          i++;                                         //Goto next line in config_file and load line into tmporary_obj
          tmpline_obj=(lineObj) linearray.get(i);
          //Search for path
          if((tmpline_obj.line.substring(0,8).equals("\"Path\"=\""))==true)
          {
            tmpvalue_of_Path=tmpline_obj.line.substring(8,(tmpline_obj.line.length()-1));
          }
          else
          {
            if((tmpline_obj.line.substring(0,9).equals("\"Path\" =\""))==true)
            {
                tmpvalue_of_Path=tmpline_obj.line.substring(9,(tmpline_obj.line.length()-1));
            }
              if((tmpline_obj.line.substring(0,9).equals("\"Path\"= \""))==true)
              {
                  tmpvalue_of_Path=tmpline_obj.line.substring(9,(tmpline_obj.line.length()-1));
              }
              else
              {
                if((tmpline_obj.line.substring(0,10).equals("\"Path\" = \""))==true) //Maybe the user made some mistakes in configarion...
                {
                  tmpvalue_of_Path=tmpline_obj.line.substring(10,(tmpline_obj.line.length()-1));
                }
                else
                {
                  System.out.print("\nYour Config-File look corrupted in Line:"+tmpline_obj.linenumber+"at poit"+(tmpline_obj.line.substring(0,10)));
		  ok=false;                              //Say that there went someting wrong
		}
              }
          }

          i++;                                                             //now go one line forward..
          tmpline_obj=(lineObj) linearray.get(i);
          //Search for Type
          if((tmpline_obj.line.substring(0,8).equals("\"Type\"=\""))==true)
          {
            tmpvalue_of_Type=tmpline_obj.line.substring(8,(tmpline_obj.line.length()-1));
          }
          else
          {
            if((tmpline_obj.line.substring(0,9).equals("\"Type\" =\""))==true)
            {
                tmpvalue_of_Type=tmpline_obj.line.substring(9,(tmpline_obj.line.length()-1));
            }
              if((tmpline_obj.line.substring(0,9).equals("\"Type\"= \""))==true)
              {
                  tmpvalue_of_Type=tmpline_obj.line.substring(9,(tmpline_obj.line.length()-1));
              }
              else
              {
                if((tmpline_obj.line.substring(0,10).equals("\"Type\" = \""))==true) //Maybe the user made some mistakes in configarion...
                {
                  tmpvalue_of_Type=tmpline_obj.line.substring(10,(tmpline_obj.line.length()-1));
                }
                else
                {
                  System.out.print("\nYour Config-File look corrupted in Line:"+tmpline_obj.linenumber+"at poit"+(tmpline_obj.line.substring(0,10)));
		  ok=false;
		}
              }
          }

          i++;                                                             //now go one line forward..
          tmpline_obj=(lineObj) linearray.get(i);
          //Search for Device

          if((tmpline_obj.line.substring(0,10).equals("\"Device\"=\""))==true)
          {
            tmpvalue_of_Device=tmpline_obj.line.substring(10,(tmpline_obj.line.length()-1));
          }
          else
          {
            if((tmpline_obj.line.substring(0,11).equals("\"Device\" =\""))==true)
            {
                tmpvalue_of_Device=tmpline_obj.line.substring(11,(tmpline_obj.line.length()-1));
            }
              if((tmpline_obj.line.substring(0,11).equals("\"Device\"= \""))==true)
              {
                  tmpvalue_of_Device=tmpline_obj.line.substring(11,(tmpline_obj.line.length()-1));
              }
              else
              {
                if((tmpline_obj.line.substring(0,12).equals("\"Device\" = \""))==true) //Maybe the user made some mistakes in configarion...
                {
                  tmpvalue_of_Device=tmpline_obj.line.substring(12,(tmpline_obj.line.length()-1));
                }
                else
                {
                  //System.out.print("\nThere was no Device-Entry in Line:"+tmpline_obj.linenumber+"at poit"+(tmpline_obj.line.substring(0,10))+". Will simply create a pseudo-value");
                  tmpvalue_of_Device= null;
                  //If theres no device_entry, set the fs directly
                  if((tmpline_obj.line.substring(0,14).equals("\"Filesystem\"=\""))==true)
                  {
                    tmpvalue_of_Filesystem=tmpline_obj.line.substring(14,(tmpline_obj.line.length()-1));
                    tmpdrive_obj=new driveObj(tmpname, tmpvalue_of_Path, tmpvalue_of_Type, tmpvalue_of_Device, tmpvalue_of_Filesystem);
                    drivearray.add(tmpdrive_obj);

                  }
                  else
                  {
                  if((tmpline_obj.line.substring(0,15).equals("\"Filesystem\" =\""))==true)
                  {
                    tmpvalue_of_Filesystem=tmpline_obj.line.substring(15,(tmpline_obj.line.length()-1));
                    tmpdrive_obj=new driveObj(tmpname, tmpvalue_of_Path, tmpvalue_of_Type, tmpvalue_of_Device, tmpvalue_of_Filesystem);
                    drivearray.add(tmpdrive_obj);
                  }
                 if((tmpline_obj.line.substring(0,15).equals("\"Filesystem\"= \""))==true)
                  {
                    tmpvalue_of_Filesystem=tmpline_obj.line.substring(15,(tmpline_obj.line.length()-1));
                    tmpdrive_obj=new driveObj(tmpname, tmpvalue_of_Path, tmpvalue_of_Type, tmpvalue_of_Device, tmpvalue_of_Filesystem);
                    drivearray.add(tmpdrive_obj);
                  }
                  else
                  {
                  if((tmpline_obj.line.substring(0,16).equals("\"Filesystem\" = \""))==true) //Maybe the user made some mistakes in configarion...
                  {
                    tmpvalue_of_Filesystem=tmpline_obj.line.substring(16,(tmpline_obj.line.length()-1));
                    tmpdrive_obj=new driveObj(tmpname, tmpvalue_of_Path, tmpvalue_of_Type, tmpvalue_of_Device, tmpvalue_of_Filesystem);
                    drivearray.add(tmpdrive_obj);
                  }
                  else
                  {
                   // System.out.print("\nparserd Filesystem -> no device entry in Line:"+tmpline_obj.linenumber+"at poit"+(tmpline_obj.line.substring(0,10)));
		    ok=false;
		  }
                }
                 }

                 }
                }
                }

          i++;                                                             //now go one line forward..
          tmpline_obj=(lineObj) linearray.get(i);
          //Search for Filesystem
           if((tmpline_obj.line.length())>13)                //Check if string of this line is bigger as 6 -> for check below..
           {
           if((tmpline_obj.line.substring(0,14).equals("\"Filesystem\"=\""))==true)
            {
              tmpvalue_of_Filesystem=tmpline_obj.line.substring(14,(tmpline_obj.line.length()-1));
                    tmpdrive_obj=new driveObj(tmpname, tmpvalue_of_Path, tmpvalue_of_Type, tmpvalue_of_Device, tmpvalue_of_Filesystem);
                    drivearray.add(tmpdrive_obj);
            }
            else
            {
              if((tmpline_obj.line.substring(0,15).equals("\"Filesystem\" =\""))==true)
              {
                    tmpvalue_of_Filesystem=tmpline_obj.line.substring(15,(tmpline_obj.line.length()-1));
                    tmpdrive_obj=new driveObj(tmpname, tmpvalue_of_Path, tmpvalue_of_Type, tmpvalue_of_Device, tmpvalue_of_Filesystem);
                    drivearray.add(tmpdrive_obj);
              }
                if((tmpline_obj.line.substring(0,15).equals("\"Filesystem\"= \""))==true)
                {
                   tmpvalue_of_Filesystem=tmpline_obj.line.substring(15,(tmpline_obj.line.length()-1));
                   tmpdrive_obj=new driveObj(tmpname, tmpvalue_of_Path, tmpvalue_of_Type, tmpvalue_of_Device, tmpvalue_of_Filesystem);
                   drivearray.add(tmpdrive_obj);;
                }
                else
                {
                  if((tmpline_obj.line.substring(0,16).equals("\"Filesystem\" = \""))==true) //Maybe the user made some mistakes in configarion...
                  {
                   tmpvalue_of_Filesystem=tmpline_obj.line.substring(16,(tmpline_obj.line.length()-1));
                   tmpdrive_obj=new driveObj(tmpname, tmpvalue_of_Path, tmpvalue_of_Type, tmpvalue_of_Device, tmpvalue_of_Filesystem);
                   drivearray.add(tmpdrive_obj);
                  }
                  else
                  {
                     System.out.print("\nYour Config-File looks corrupted in Line:"+tmpline_obj.linenumber+"at poit"+(tmpline_obj.line.substring(0,13)));
		     ok=false;
		  }
                }
            }
          }
          }
      	  }
  	  }
    return drivearray;
  }
}

